-- by mor2000

_m=_G;

_m.modDirectory = g_currentModDirectory

function _m.emptyFunc() end

_m.times10 = {}
_m.times10_mt = {
	__index = function(t,k)
		local result = 10^k
		rawset(t,k,result)
		return result
	end
	}
setmetatable(times10, times10_mt)

function _m.getMinMaxKeys(t)
	if t==nil or type(t)~="table" then
		return nil, nil
	end
	if #t>0 then
		local mink = math.huge
		local maxk = -math.huge
		for k,_ in pairs(t) do
			mink = math.min(mink,k)
			maxk = math.max(maxk,k)
		end
		return mink, maxk
	end
	return nil, nil
end;

function _m.round(nr, digits)
	if type(nr)=="number" then
		digits = digits or 0
		local result = math.floor(nr*times10[digits]+0.5)/times10[digits]
		return result
	else
		print('Error: round() called with non-number, returning 0')
		return 0
	end
end;

function _m.isPlayerActive()
	return g_gui.currentGui==nil and
			g_currentMission.controlPlayer and
			g_currentMission.player~=nil and
			g_currentMission.player.currentToolId==0
end

function _m.getCameraPositionAndRotation()
	if isPlayerActive() then
		local camx, camy, camz = getWorldTranslation(g_currentMission.player.cameraId)
		local dirx, diry, dirz = localDirectionToWorld(g_currentMission.player.cameraId, 0, 0, -1)
		local rotY = (g_currentMission.player.rotY+math.pi) % (2*math.pi) - math.pi
		return camx, camy, camz, dirx, diry, dirz, rotY
	end
end

function _m.getIsObject(shapeId)
	local object = g_currentMission.nodeObjects[shapeId] or
					g_currentMission.objectToTrailer[shapeId] or
					g_currentMission.nodeToVehicle[shapeId]
	if object~=nil and object.isa~=nil and object:isa(Object) then
		return true
	end
	return false
end

function _m.getIsLog(shapeId)
	local splitType = SplitUtil.splitTypes[getSplitType(shapeId)]
	if splitType~=nil then
		return true
	end
	return false
end

function _m.getSquareBaleMultiplier(shapeId, multiplier)
	local object = g_currentMission.nodeObjects[shapeId]
	if object~=nil and object.isa~=nil and object:isa(Bale) and not object.isRoundbale then
		return multiplier
	end
	return 1
end